// Generated by CoffeeScript 1.9.3

/* Copyright Information
	 * @author	Tim Düsterhus
	 * @copyright	2012-2015 Tim Düsterhus
	 * @license	BSD 3-Clause License <http://opensource.org/licenses/BSD-3-Clause>
	 * @package	be.bastelstu.wcf.push
 */

(function() {
  (function($, window) {
    "use strict";
    var base, connected, console, events, init, initialized, onConnect, onDisconnect, onMessage, service;
    console = {
      log: function(message) {
        if (typeof production === "undefined" || production === null) {
          return window.console.log("[be.bastelstu.wcf.push] " + message);
        }
      },
      warn: function(message) {
        if (typeof production === "undefined" || production === null) {
          return window.console.warn("[be.bastelstu.wcf.push] " + message);
        }
      },
      error: function(message) {
        if (typeof production === "undefined" || production === null) {
          return window.console.error("[be.bastelstu.wcf.push] " + message);
        }
      }
    };
    initialized = false;
    service = null;
    connected = false;
    events = {
      message: {}
    };
    init = function(_service) {
      var i, intervalLength, len, ref, results;
      if (initialized) {
        return;
      }
      initialized = true;
      service = _service;
      service.onConnect(function() {
        return connected = true;
      });
      service.onDisconnect(function() {
        return connected = false;
      });
      ref = [15, 30, 60, 90, 120];
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        intervalLength = ref[i];
        results.push((function(intervalLength) {
          return setInterval(function() {
            var message;
            if (!connected) {
              return;
            }
            message = "be.bastelstu.wcf.push.tick" + intervalLength;
            if (events.message[message] == null) {
              return;
            }
            return events.message[message].fire();
          }, intervalLength * 1e3);
        })(intervalLength));
      }
      return results;
    };
    onConnect = function(callback) {
      if (!$.isFunction(callback)) {
        return false;
      }
      if (initialized) {
        return service.onConnect(callback);
      } else {
        console.warn("Someone tried to bind an onConnect callback before initialization of a service");
        return false;
      }
    };
    onDisconnect = function(callback) {
      if (!$.isFunction(callback)) {
        return false;
      }
      if (initialized) {
        return service.onDisconnect(callback);
      } else {
        console.warn("Someone tried to bind an onDisonnect callback before initialization of a service");
        return false;
      }
    };
    onMessage = function(message, callback) {
      var base;
      if (!$.isFunction(callback)) {
        return false;
      }
      if (!/^[a-zA-Z0-9-_]+\.[a-zA-Z0-9-_]+(\.[a-zA-Z0-9-_]+)+$/.test(message)) {
        return false;
      }
      if (initialized) {
        if (/be\.bastelstu\.wcf\.push.tick(15|(3|6|9|12)0)/.test(message)) {
          if ((base = events.message)[message] == null) {
            base[message] = $.Callbacks();
          }
          events.message[message].add(callback);
          return true;
        } else {
          return service.onMessage(message, callback);
        }
      } else {
        console.warn("Someone tried to bind an onMessage(" + message + ") callback before initialization of a service");
        return false;
      }
    };
    if (window.be == null) {
      window.be = {};
    }
    if (be.bastelstu == null) {
      be.bastelstu = {};
    }
    if ((base = be.bastelstu).wcf == null) {
      base.wcf = {};
    }
    return be.bastelstu.wcf.push = {
      init: init,
      onConnect: onConnect,
      onDisconnect: onDisconnect,
      onMessage: onMessage
    };
  })(jQuery, this);

}).call(this);
